#include <iostream>
#include <vector>
using namespace std;
const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
int main()
{
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    vector<double> numbers(number_count);
    cerr << "Enter numbers: ";
    for(size_t i = 0; i < number_count; i++){
        cin >> numbers[i];
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;

    double min = numbers[0];
    double max = numbers[0];
    /*
    for (size_t x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
    */
    for (size_t i=1; i<number_count; i++){
            if (numbers[i]<min){
                min=numbers[i];
            }
            else if (numbers[i]>max){
                max=numbers[i];
            }
    }
    vector<size_t> bins(bin_count);
    double bin_size = (max-min)/bin_count;
    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ( (numbers[i] >= lo) && (numbers[i] < hi) ) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count-1]++;
        }

    }
    size_t max_count = bins[0];
    for(size_t x: bins){
        if(x > max_count){
            max_count = x;
        }
    }
    vector<size_t> heights(bin_count);
    if (max_count>MAX_ASTERISK){
        for (size_t i = 0; i < bin_count; i++){
            heights[i] = MAX_ASTERISK * (static_cast<double>(bins[i]) /max_count);
        }
    }
    else{
        for (size_t i=0; i<bin_count; i++){
            heights[i] = bins[i];
        }
    }
    for(size_t i=0; i<bin_count; i++){
        if (bins[i] < 10){
            cout << "  " << bins[i] << "|";
        }
        else if (bins[i] < 100){
            cout << " " << bins[i] << "|";
        }
        else{
            cout << bins[i] << "|";
        }
        for (size_t j=0; j<heights[i]; j++){
            cout<<"*";
        }
        cout<<"\n";
    }
    return 0;
}
